// ArchiveCtrl.cpp : ̒`
//
// ---------------------------------------------------------------------------
//
//	CArchiveCtrl	A[JCuRg[NX
//					ZIP,LHA A[JCu DLL ̃bp[
//	
//	CREATE	2002.12.16	by HIRO <shirai@as.email.ne.jp>
//
// ---------------------------------------------------------------------------

#include <windows.h>
#include <assert.h>
#include "ArchiveCtrl.h"

/*-------------------------------------------------------------------------*/
// CArchiveCtrl			NX̃RXgN^
/*-------------------------------------------------------------------------*/
CArchiveCtrl::CArchiveCtrl()
	:	m_ListCount(0),
		m_ListMaxCount(0),
		m_Mode(0),
		m_FileLisrP(NULL),
		m_DllH(NULL)
{
}

/*-------------------------------------------------------------------------*/
// ~CArchiveCtrl		NX̃fXgN^
/*-------------------------------------------------------------------------*/
CArchiveCtrl::~CArchiveCtrl()
{
	// t@CXg̔j
	PurgeFileList();

	// A[JCoDLL̃[X
	DetachDll();
}

/*-------------------------------------------------------------------------*/
// AttachDll			ckkA^b`
/*-------------------------------------------------------------------------*/
void CArchiveCtrl::AttachDll()
{
	if (m_DllH)	return;	// A^b`

	switch (m_Mode)	{
		case ZIP:
			m_DllH = ::LoadLibrary("UNZIP32.DLL");
			break;
		case LHA:
			m_DllH = ::LoadLibrary("UNLHA32.DLL");
			break;
		default:
			assert(FALSE);
	}
}

/*-------------------------------------------------------------------------*/
// DetachDll			ckkf^b`
/*-------------------------------------------------------------------------*/
void CArchiveCtrl::DetachDll()
{
	if(m_DllH)	{
		::FreeLibrary(m_DllH);
		m_DllH = NULL;
	}
}

/*-------------------------------------------------------------------------*/
// PurgeFileList		t@CXg̔j
/*-------------------------------------------------------------------------*/
void CArchiveCtrl::PurgeFileList()
{
	// GÅJ
	if (m_FileLisrP)	{
		for (UINT i=0;i<m_ListMaxCount;i++)	{
			if (m_FileLisrP[i].FileNameP)	{
				delete [] m_FileLisrP[i].FileNameP;
			}
		}
		delete [] m_FileLisrP;
	}
	m_FileLisrP		= NULL;
	m_ListMaxCount	= 0;
	m_ListCount		= 0;
}

/*-------------------------------------------------------------------------*/
// MakeArcFileList		A[JCut@CXg쐬
/*-------------------------------------------------------------------------*/
ARC_FILE_LIST* CArchiveCtrl::MakeArcFileList(
	INT		inMode,
	LPCSTR	inPathP,
	UINT	inMaxCount,
	UINT*	outCount)
{
	// A[JCuw
	m_Mode = inMode;
	assert(m_Mode == 0 || m_Mode == 1);

	// t@CXg̔j(ÔNA)
	PurgeFileList();

	// ckkA^b`
	AttachDll();

	// ԕ
	assert(inMaxCount > 0);
	assert(m_DllH != NULL);
	if (m_DllH == NULL	||
		inMaxCount == 0)		return NULL;

	// DLLɊ֐̎QƂ邩`FbN
	ARC_FINDFIRST	 fpFindFirst	= NULL;
	ARC_FINDNEXT	 fpFindNext		= NULL;
	ARC_OPENARCHIVE	 fpOpenArchive	= NULL;
	ARC_CLOSEARCHIVE fpCloseArchive	= NULL;
	if (m_Mode == ZIP)	{
		fpOpenArchive	= (ARC_OPENARCHIVE)GetProcAddress(m_DllH,ZIP_OPENARCHIVE);
		fpCloseArchive	= (ARC_CLOSEARCHIVE)GetProcAddress(m_DllH,ZIP_CLOSEARCHIVE);	
		fpFindFirst		= (ARC_FINDFIRST)GetProcAddress(m_DllH,ZIP_FINDFIRST);
		fpFindNext		= (ARC_FINDNEXT)GetProcAddress(m_DllH,ZIP_FINDNEXT);
	}
	else if (m_Mode == LHA)	{
		fpOpenArchive	= (ARC_OPENARCHIVE)GetProcAddress(m_DllH,LHA_OPENARCHIVE);
		fpCloseArchive	= (ARC_CLOSEARCHIVE)GetProcAddress(m_DllH,LHA_CLOSEARCHIVE);	
		fpFindFirst		= (ARC_FINDFIRST)GetProcAddress(m_DllH,LHA_FINDFIRST);
		fpFindNext		= (ARC_FINDNEXT)GetProcAddress(m_DllH,LHA_FINDNEXT);
	}

	if (fpOpenArchive	== NULL	||
		fpCloseArchive	== NULL	||
		fpFindFirst		== NULL	||
		fpFindNext		== NULL)	return NULL;

	// ǂݍ݃GA쐬
	m_ListMaxCount = inMaxCount;
	m_FileLisrP = new ARC_FILE_LIST[m_ListMaxCount];
	ZeroMemory(m_FileLisrP,sizeof(ARC_FILE_LIST) * m_ListMaxCount);

	// ǂݍݏ
	INDIVIDUALINFO	theIInfo;
	HARC	theArcH = (*fpOpenArchive)(NULL,inPathP,
							M_INIT_FILE_USE + M_CHECK_ALL_PATH + M_ERROR_MESSAGE_OFF);
	if (theArcH)	{
		INT	result = (*fpFindFirst)(theArcH,"*",&theIInfo);
		while (result == 0)	{
			// e[uɐݒ
			m_FileLisrP[m_ListCount].FileNameP = 
						new CHAR[strlen(theIInfo.szFileName)+1];
			strcpy(m_FileLisrP[m_ListCount].FileNameP,theIInfo.szFileName);
			m_FileLisrP[m_ListCount].Date			= theIInfo.wDate;
			m_FileLisrP[m_ListCount].Time			= theIInfo.wTime;
			m_FileLisrP[m_ListCount].OriginalSize	= theIInfo.dwOriginalSize;
			m_FileLisrP[m_ListCount].CompressedSize	= theIInfo.dwCompressedSize;
			m_ListCount++;
			if (m_ListCount >= m_ListMaxCount)	break;	// ő			
			// ǂݍ
			result = (*fpFindNext)(theArcH,&theIInfo);
		}
		(*fpCloseArchive)(theArcH);
	}
	
	// ǂݍ݌߂
	if (outCount)	*outCount = m_ListCount;

	// ckkf^b`
	DetachDll();

	return m_FileLisrP;
}

/*-------------------------------------------------------------------------*/
// DosDate2Ymd		tϊ
/*-------------------------------------------------------------------------*/
void CArchiveCtrl::DosDate2Ymd(
	WORD	inWDate,
	YYMMDD*	outYmd)
{
	// ʂVrbgPXWON̔NCSrbgCĉTrbg
	assert(outYmd != NULL);
	if (outYmd == NULL)	return;
	
	// vZ
	union {
		WORD wDate;
		struct {
			unsigned ft_day   : 5;
			unsigned ft_month : 4;
			unsigned ft_year  : 7; // 1980ŇoߔN
		} Date;
	} DosDate;
	DosDate.wDate = inWDate;
	outYmd->yy = DosDate.Date.ft_year + 1980;
	outYmd->mm = DosDate.Date.ft_month;
	outYmd->dd = DosDate.Date.ft_day;
}

/*-------------------------------------------------------------------------*/
// DosTime2Hms		ԕϊ
/*-------------------------------------------------------------------------*/
void CArchiveCtrl::DosTime2Hms(
	WORD	inWTime,
	HHMMSS*	outHms)
{
	// ʂTrbgԁCUrbgCĉTrbgbQŊ
	assert(outHms != NULL);
	if (outHms == NULL)	return;

	// vZ
	union {
		WORD wTime;
		struct {
			unsigned ft_tsec : 5; // b2Ŋ
			unsigned ft_min  : 6;
			unsigned ft_hour : 5;
		} Time;
	} DosTime;
	DosTime.wTime = inWTime;
	outHms->hh = DosTime.Time.ft_hour;
	outHms->mm = DosTime.Time.ft_min;
	outHms->ss = DosTime.Time.ft_tsec * 2;
}

